$(document).ready(function(){

	//GLOBAL VAR
	var XMLSource = $('#data').attr('xmlData');
	var keyword = '';
	var catType = '';
	var pub = '';
						   
	var i = 0;
	
	
	
  var timeoutID = null;

  function findMember(str) 
  {
    console.log('search: ' + str);
	//location.reload();
	
	
   
  for (var i = 0; i < tags.length; i++) 
  {
    alert(tags[i].nodeName + ' = ' + tags[i].firstChild.nodeValue);
  }
  }

  $('#term').keyup(function(e) 
  {
    clearTimeout(timeoutID);
    timeoutID = setTimeout(findMember.bind(undefined, term.value), 100);
    searchThis();
  });
  

	
	
	
	
   
	$("#searchButton").click(function() {
		keyword = $("input#term").val();
		catType = $("#category option:selected").val();
		
		//Reset any message
		var errMsg = '';
		pub = '';
	
		if ( keyword == ' ' ) { errMsg += 'Please enter a search term' + '\n'; }
		else { searchThis(); }

		if ( errMsg != '' ) {
			pub += '<div class="error">' + '\n';
			pub += errMsg;
			pub += '</div>' + '\n';
		}
		
		//Show error
		$('#result').html( pub );

	});
	

	
	function searchThis() {				
		$.ajax({
			type: "GET",
			url: XMLSource,
			dataType: "xml",
			success: function(xml) { loadPublication (xml) }	
		});
	}
	
	function loadPublication (xmlData) {
		i = 0;
		var row;
		
		var searchExp = "";
		
		$(xmlData).find('staff-listing').each(function(){
			
			var name = $(this).find('name').text();
			var abbr = $(this).find('abbr').text();
			var address = $(this).find('address').text();
			var city = $(this).find('city').text();
			var pc = $(this).find('pc').text();
			
			//Format the keyword expression
			var exp = new RegExp(keyword,"gi");
			
			//Check if there is a category selected; 
			//if not, use address column as a default search
			if ( catType == 'name' ) { searchExp = name.match(exp); }
			else if ( catType == 'abbr' ) { searchExp = abbr.match(exp); }
			else if ( catType == 'address' ) { searchExp = address.match(exp); }
			else if ( catType == '' ) { searchExp = address.match(exp); }
			
			if ( searchExp != null ) {
				
				//Start building the result
				if ((i % 2) == 0) { row = 'even'; }
				else { row = 'odd'; }
				
				i++;				
				
				pub += '<tr class="row ' + row + '">' + '\n';
				pub += '<td valign="top" class="col1">' + name + '</td>' + '\n';	
				pub += '<td valign="top" class="col2">' + abbr + '</td>' + '\n';	
				pub += '<td valign="top" class="col3">' + address + '</td>' + '\n';	
				pub += '<td valign="top" class="col4">' + city + '</td>' + '\n';	
				pub += '<td valign="top" class="col5">' + pc + '</td>' + '\n';	
				pub += '</tr>' + '\n';
			}	
		});
				
		if ( i == 0 ) {
			pub += '<div class="error">' + '\n';
			pub += 'No Result was Found' + '\n';	
			pub += '</div>' + '\n';
			
			//Populate the result
			$('#result').html( pub );
		}
		else {
			//Pass the result set
			showResult ( pub );
		}
	}
	
	function showResult (resultSet) {

		//Show the result
		pub = '<table id="grid" border="0">' + '\n';
		pub += '<thead><tr>' + '\n';
		pub += '<th class="col1">Name</th>' + '\n';
		pub += '<th class="col2">Abbreviation</th>' + '\n';
		pub += '<th class="col3">Address</th>' + '\n';
		pub += '<th class="col4">City</th>' + '\n';
		pub += '<th class="col5">Postal Code</th>' + '\n';
		pub += '</tr></thead>' + '\n';
		pub += '<tbody>' + '\n';
		
		pub += resultSet;
		
		pub += '</tbody>' + '\n';
		pub += '</table>' + '\n';
		
		//Populate 
		$('#result').html(pub)
		
		$('#grid').tablesorter(); 
	}
});