    "use strict";
  
  var string = document.getElementById("string").value;
  var parser = new DOMParser();
  var data = parser.parseFromString(string,"application/xml");
  var searchField = document.getElementById("term");
  var resultList = document.getElementById("result");

  function searchByName(term){
    return Array.from(
      data.documentElement.children
    ).filter(
      element => !term
              || element.getElementsByTagName("section")[0]
            
                   .textContent.toLowerCase()
                   .indexOf(term.toLowerCase()) != -1
    );
  }

  class SearchResultElement 
  {
    constructor(staffListing)
	{
      this.section = staffListing.getElementsByTagName("section")[0].textContent;
      this.abbr = staffListing.getElementsByTagName("abbr")[0].textContent;
      this.name = staffListing.getElementsByTagName("name")[0].textContent;
	  this.address = staffListing.getElementsByTagName("address")[0].textContent;
	  this.city = staffListing.getElementsByTagName("city")[0].textContent;
	  this.pc = staffListing.getElementsByTagName("pc")[0].textContent;
	  
	  
      this.root = document.createElement("li");
      this.update();
    }
	
    update()
	{
      this.root.innerHTML = '';
      this.root.appendChild(
        document.createTextNode(
          this.section+ ',' +this.abbr+ ',' +this.name+ ',' +this.address+ ',' +this.city+ ',' +this.pc;
        )
      );
    }
	
    getRoot(){
      return this.root;
    }
  }
  
  

  function update()
  {
    var results = searchByName(searchField.value);
    resultList.innerHTML = '';
    for( var result of results )
	{
      var element = new SearchResultElement(result);
      resultList.appendChild(element.getRoot());
    }
  }

  searchField.oninput = update;
  update();